## tomopy 1.10.4+ds1

=== CMakeLists.txt ===
################################################################################
#   cmake settings
#
cmake_minimum_required(VERSION 3.3 FATAL_ERROR)

if("${CMAKE_SOURCE_DIR}" STREQUAL "${CMAKE_BINARY_DIR}")
    set(MSG "")
    message(STATUS "Warning! Building from the source directory is not recommended")
    message(STATUS "If unintented, please remove 'CMakeCache.txt' and 'CMakeFiles'")
    message(STATUS "and build from a separate directory")
    message(WARNING "In-source build")
endif()

cmake_policy(SET CMP0048 NEW)
cmake_policy(SET CMP0042 NEW)

# Check if pybind11 is being used directly or via add_subdirectory
set(PTL_MASTER_PROJECT ON)
if(NOT CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
  set(PTL_MASTER_PROJECT OFF)
endif()

################################################################################
#   version
#
file(READ "${CMAKE_CURRENT_LIST_DIR}/VERSION" VERSION_STRING LIMIT_COUNT 1)
string(REGEX REPLACE "(\n|\r)" "" VERSION_STRING "${VERSION_STRING}")
string(REGEX REPLACE "[A-Za-z].*" "" VERSION_STRING "${VERSION_STRING}")
set(PTL_VERSION "${VERSION_STRING}" CACHE STRING "Version of PTL project" FORCE)
message(STATUS "PTL version ${PTL_VERSION}")


################################################################################
#   project
#
project(PTL LANGUAGES C CXX VERSION ${PTL_VERSION})
if(NOT PTL_MASTER_PROJECT)
    unset(${PROJECT_NAME}_C_FLAGS CACHE)
    unset(${PROJECT_NAME}_CXX_FLAGS CACHE)
endif()
set(CMAKE_DIRECTORY_LABELS "PTL")

################################################################################
#
#
set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_LIST_DIR}/cmake/Modules ${CMAKE_MODULE_PATH})

foreach(_TYPE MAJOR MINOR PATCH)
    set(PTL_VERSION_${_TYPE} ${PROJECT_VERSION_${_TYPE}}
        CACHE STRING "PTL ${_TYPE} version" FORCE)
    mark_as_advanced(PTL_VERSION_${_TYPE})
endforeach(_TYPE MAJOR MINOR PATCH)

set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_LIST_DIR}/cmake/Modules ${CMAKE_MODULE_PATH})
set(CMAKE_INSTALL_DEFAULT_COMPONENT_NAME development)
mark_as_advanced(PTL_VERSION)

################################################################################

include(MacroUtilities)
include(Options)
include(Compilers)
include(GNUInstallDirs)
include(ProjectSettings)
include(BuildSettings)
include(Packages)
include(ClangFormat)

################################################################################
#   PTL source
################################################################################

add_subdirectory(source)

################################################################################
#   Installation and info
################################################################################

include(ConfigurePackage)

if(PTL_BUILD_EXAMPLES)
    set(PTL_DIR ${CMAKE_BINARY_DIR})
    add_subdirectory(examples)
endif()

if(PTL_MASTER_PROJECT)
    print_features()
else()
    set(${PROJECT_NAME}_C_FLAGS ${${PROJECT_NAME}_C_FLAGS} CACHE STRING
        "C compiler flags for ${PROJECT_NAME}")
    set(${PROJECT_NAME}_CXX_FLAGS ${${PROJECT_NAME}_CXX_FLAGS} CACHE STRING
        "CXX compiler flags for ${PROJECT_NAME}")
endif()

=== doc/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = _build

# User-friendly check for sphinx-build
ifeq ($(shell which $(SPHINXBUILD) >/dev/null 2>&1; echo $$?), 1)
$(error The '$(SPHINXBUILD)' command was not found. Make sure you have Sphinx installed, then set the SPHINXBUILD environment variable to point to the full path of the '$(SPHINXBUILD)' executable. Alternatively you can add the directory with the executable to your PATH. If you don't have Sphinx installed, grab it from http://sphinx-doc.org/)
endif

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source
# the i18n builder cannot share the environment and doctrees with the others
I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest gettext

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  latexpdfja to make LaTeX files and run them through platex/dvipdfmx"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  texinfo    to make Texinfo files"
	@echo "  info       to make Texinfo files and run them through makeinfo"
	@echo "  gettext    to make PO message catalogs"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  xml        to make Docutils-native XML files"
	@echo "  pseudoxml  to make pseudoxml-XML files for display purposes"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"

clean:
	rm -rf $(BUILDDIR)/*

html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/TomoGrid.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/TomoGrid.qhc"

devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/TomoGrid"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/TomoGrid"
	@echo "# devhelp"

epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

latexpdfja:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through platex and dvipdfmx..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf-ja
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

texinfo:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo
	@echo "Build finished. The Texinfo files are in $(BUILDDIR)/texinfo."
	@echo "Run \`make' in that directory to run these through makeinfo" \
	      "(use \`make info' here to do that automatically)."

info:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo "Running Texinfo files through makeinfo..."
	make -C $(BUILDDIR)/texinfo info
	@echo "makeinfo finished; the Info files are in $(BUILDDIR)/texinfo."

gettext:
	$(SPHINXBUILD) -b gettext $(I18NSPHINXOPTS) $(BUILDDIR)/locale
	@echo
	@echo "Build finished. The message catalogs are in $(BUILDDIR)/locale."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

xml:
	$(SPHINXBUILD) -b xml $(ALLSPHINXOPTS) $(BUILDDIR)/xml
	@echo
	@echo "Build finished. The XML files are in $(BUILDDIR)/xml."

pseudoxml:
	$(SPHINXBUILD) -b pseudoxml $(ALLSPHINXOPTS) $(BUILDDIR)/pseudoxml
	@echo
	@echo "Build finished. The pseudo-XML files are in $(BUILDDIR)/pseudoxml."

=== examples/CMakeLists.txt ===
# $Id: CMakeLists.txt 100707 2016-10-31 20:21:07Z ihrivnac $

#----------------------------------------------------------------------------
# Setup the project
#
cmake_minimum_required(VERSION 3.3 FATAL_ERROR)
project(PTL_Examples LANGUAGES C CXX VERSION ${PTL_VERSION})

# add the common "library"
add_subdirectory(common)
list(APPEND EXTERNAL_LIBRARIES common)

add_subdirectory(basic)
add_subdirectory(extended)
add_subdirectory(gpu)

=== source/CMakeLists.txt ===
################################################################################
#                                                                              #
#                               General                                        #
#                                                                              #
################################################################################
# ensure PIC flag is set
set(PYTHON_SITE_DIR ${CMAKE_INSTALL_PREFIX}/source)
set(BUILD_STATIC_LIBS     ON  CACHE BOOL "Build static libraries")
set(BUILD_SHARED_LIBS     OFF CACHE BOOL "Build shared libraries")
set(PTL_DEVELOPER_INSTALL OFF CACHE BOOL "Install headers, cmake export, and shared libs" FORCE)
set(CMAKE_POSITION_INDEPENDENT_CODE ON
    CACHE BOOL "Position independent code" FORCE)
set(CMAKE_INSTALL_LIBDIR ${PYTHON_SITE_DIR}/tomopy/util/extern
    CACHE PATH "Installation directory of libraries" FORCE)

#------------------------------------------------------------------------------#
#
#   PTL submodule
#
#------------------------------------------------------------------------------#
checkout_git_submodule(RECURSIVE TEST_FILE CMakeLists.txt
    RELATIVE_PATH source/PTL WORKING_DIRECTORY ${PROJECT_SOURCE_DIR})

if(TOMOPY_USE_PTL)
    add_subdirectory(PTL)
    if(BUILD_STATIC_LIBS)
        list(APPEND TOMOPY_EXTERNAL_LIBRARIES ptl-static)
    else()
        list(APPEND TOMOPY_EXTERNAL_LIBRARIES ptl-shared)
    endif()
    list(APPEND ${PROJECT_NAME}_DEFINITIONS TOMOPY_USE_PTL)
endif()

#------------------------------------------------------------------------------#
#
#   TomoPy Python module
#
#------------------------------------------------------------------------------#

# where to place the library
set(OUTPUT_PATH ${CMAKE_BINARY_DIR})

add_subdirectory(${CMAKE_CURRENT_LIST_DIR}/libtomo)

#------------------------------------------------------------------------------#
#
#   TomoPy Python file configuration
#
#------------------------------------------------------------------------------#
if(NOT SKBUILD)
    # helper macro
    macro(CONFIG_INSTALL RELATIVE_PATH)
        foreach(_SOURCE_FILE ${ARGN})
            string(REPLACE "${CMAKE_CURRENT_LIST_DIR}" "${PROJECT_BINARY_DIR}" _BINARY_FILE
                "${_SOURCE_FILE}")
            configure_file(${_SOURCE_FILE} ${_BINARY_FILE} COPYONLY)
            install(FILES ${_BINARY_FILE}
                DESTINATION ${PYTHON_SITE_DIR}/tomopy/${RELATIVE_PATH}
                COMPONENT python)
        endforeach()
    endmacro()

    # Copy over pure python module, python testing, and setup files
    file(GLOB _GENERAL "${CMAKE_CURRENT_LIST_DIR}/tomopy/*.py")
    file(GLOB _DATA    "${CMAKE_CURRENT_LIST_DIR}/tomopy/data/*.tif"
                       "${CMAKE_CURRENT_LIST_DIR}/tomopy/data/*.h5")
    file(GLOB _MISC    "${CMAKE_CURRENT_LIST_DIR}/tomopy/misc/*.py")
    file(GLOB _PREP    "${CMAKE_CURRENT_LIST_DIR}/tomopy/prep/*.py")
    file(GLOB _RECON   "${CMAKE_CURRENT_LIST_DIR}/tomopy/recon/*.py")
    file(GLOB _SIM     "${CMAKE_CURRENT_LIST_DIR}/tomopy/sim/*.py")
    file(GLOB _UTIL    "${CMAKE_CURRENT_LIST_DIR}/tomopy/util/*.py")

    config_install("" ${_GENERAL})
    config_install("data"  ${_DATA})
    config_install("misc"  ${_MISC})
    config_install("prep"  ${_PREP})
    config_install("recon" ${_RECON})
    config_install("sim"   ${_SIM})
    config_install("util"  ${_UTIL})

    # copy of test directory to build directory
    execute_process(COMMAND ${CMAKE_COMMAND} -E copy_directory
        ${PROJECT_SOURCE_DIR}/test ${PROJECT_BINARY_DIR}/test
        WORKING_DIRECTORY ${PROJECT_BINARY_DIR})

    # copy over setup.* files to build directory
    file(GLOB PYSETUP "${PROJECT_SOURCE_DIR}/setup.*")
    execute_process(COMMAND ${CMAKE_COMMAND} -E copy_if_different
        ${PYSETUP} ${PROJECT_BINARY_DIR}/
        WORKING_DIRECTORY ${PROJECT_BINARY_DIR})
endif()

#------------------------------------------------------------------------------#
#
#   Code coverage
#
#------------------------------------------------------------------------------#
if(TOMOPY_USE_COVERAGE)
    foreach(_SRC_FILE ${LIBRARY_SOURCES})
        string(REPLACE "${CMAKE_CURRENT_SOURCE_DIR}"
            "${CMAKE_CURRENT_BINARY_DIR}" _BIN_FILE "${_SRC_FILE}")
        configure_file(${_SRC_FILE} ${_BIN_FILE} COPYONLY)
    endforeach()
endif()

=== examples/basic/CMakeLists.txt ===
#----------------------------------------------------------------------------
# Setup the project
#
cmake_minimum_required(VERSION 3.3 FATAL_ERROR)
project(PTL_Basic_Examples LANGUAGES C CXX)


#----------------------------------------------------------------------------
# Find PTL project
#
find_package(PTL REQUIRED)
set(EXTERNAL_INCLUDE_DIRS ${PTL_INCLUDE_DIRS})
set(EXTERNAL_LIBRARIES ${PTL_LIBRARIES})
include_directories(${EXTERNAL_INCLUDE_DIRS})
if(NOT DEFINED common_headers)
    get_filename_component(COMMON_DIR ${CMAKE_CURRENT_LIST_DIR} PATH)
    include_directories(${COMMON_DIR})
endif()


#----------------------------------------------------------------------------
# Source files
#
file(GLOB headers ${CMAKE_CURRENT_LIST_DIR}/*.h ${CMAKE_CURRENT_LIST_DIR}/*.hh)


#----------------------------------------------------------------------------
# standard example
#
add_executable(tasking tasking.cc ${headers})
target_link_libraries(tasking ${EXTERNAL_LIBRARIES})
set_target_properties(tasking PROPERTIES COMPILE_FLAGS ${PTL_CXX_FLAGS})

if(PTL_USE_TBB)
    add_executable(tbb_tasking tasking.cc ${headers})
    set_target_properties(tbb_tasking PROPERTIES
        COMPILE_DEFINITIONS USE_TBB_TASKS
        COMPILE_FLAGS ${PTL_CXX_FLAGS})
    target_link_libraries(tbb_tasking ${EXTERNAL_LIBRARIES})
endif(PTL_USE_TBB)


#----------------------------------------------------------------------------
# recursive example
#
add_executable(recursive_tasking recursive_tasking.cc ${headers})
target_link_libraries(recursive_tasking ${EXTERNAL_LIBRARIES})
set_target_properties(recursive_tasking PROPERTIES COMPILE_FLAGS ${PTL_CXX_FLAGS})

if(PTL_USE_TBB)
    add_executable(recursive_tbb_tasking recursive_tasking.cc ${headers})
    set_target_properties(recursive_tbb_tasking PROPERTIES
        COMPILE_DEFINITIONS USE_TBB_TASKS
        COMPILE_FLAGS ${PTL_CXX_FLAGS})
    target_link_libraries(recursive_tbb_tasking ${EXTERNAL_LIBRARIES})
endif(PTL_USE_TBB)


#----------------------------------------------------------------------------
# installation
if(NOT DEFINED PTL_DEVELOPER_INSTALL OR PTL_DEVELOPER_INSTALL)
    install(TARGETS tasking recursive_tasking DESTINATION bin)
    if(PTL_USE_TBB)
        install(TARGETS recursive_tasking recursive_tbb_tasking DESTINATION bin)
    endif(PTL_USE_TBB)
endif()

=== examples/common/CMakeLists.txt ===

file(GLOB headers ${CMAKE_CURRENT_LIST_DIR}/*.hh)
get_filename_component(COMMON_INCLUDE_DIR ${CMAKE_CURRENT_LIST_DIR} PATH)

add_library(common INTERFACE)
target_sources(common INTERFACE ${headers})
target_include_directories(common INTERFACE ${COMMON_INCLUDE_DIR})

=== examples/extended/CMakeLists.txt ===

add_subdirectory(rotation)

=== examples/gpu/CMakeLists.txt ===
#----------------------------------------------------------------------------
# Setup the project
#
cmake_minimum_required(VERSION 3.1.3 FATAL_ERROR)
project(PTL_GPU_Examples LANGUAGES C CXX)


#----------------------------------------------------------------------------
# Find PTL project
#
find_package(PTL REQUIRED)
set(EXTERNAL_INCLUDE_DIRS ${PTL_INCLUDE_DIRS})
set(EXTERNAL_LIBRARIES ${PTL_LIBRARIES})
include_directories(${EXTERNAL_INCLUDE_DIRS})
if(NOT DEFINED common_headers)
    get_filename_component(COMMON_DIR ${CMAKE_CURRENT_LIST_DIR} PATH)
    include_directories(${COMMON_DIR})
endif()


#----------------------------------------------------------------------------
# Source files
#
file(GLOB headers ${CMAKE_CURRENT_LIST_DIR}/*.h ${CMAKE_CURRENT_LIST_DIR}/*.hh)

#----------------------------------------------------------------------------
# CUDA
#
if(PTL_USE_CUDA)
    #------------------------------------------------------------------------
    # Configuration for CUDA
    #
    include(CudaConfig)

    #------------------------------------------------------------------------
    # Add the executable, and link it to the Tasking libraries
    #
    cuda_add_library(sum STATIC sum.cc sum.h sum.hh sum.cu)
    target_link_libraries(sum ${EXTERNAL_CUDA_LIBRARIES})

    cuda_add_executable(gpu_tasking gpu_tasking.cc ${headers})
    target_link_libraries(gpu_tasking sum ${EXTERNAL_LIBRARIES})
    set_target_properties(gpu_tasking
        PROPERTIES COMPILE_DEFINITIONS USE_CUDA_TASKS)
    install(TARGETS gpu_tasking DESTINATION bin)

    if(PTL_USE_TBB)
        add_executable(gpu_tbb_tasking gpu_tasking.cc ${headers})
        set_target_properties(gpu_tbb_tasking
            PROPERTIES COMPILE_DEFINITIONS "USE_TBB_TASKS")
        target_link_libraries(gpu_tbb_tasking sum ${EXTERNAL_LIBRARIES})
        install(TARGETS gpu_tbb_tasking DESTINATION bin)
    endif(PTL_USE_TBB)

    #------------------------------------------------------------------------
    # Install the executable to 'bin' directory under CMAKE_INSTALL_PREFIX
    #
endif()

=== source/libtomo/CMakeLists.txt ===
add_subdirectory(${CMAKE_CURRENT_LIST_DIR}/misc)
add_subdirectory(${CMAKE_CURRENT_LIST_DIR}/prep)
add_subdirectory(${CMAKE_CURRENT_LIST_DIR}/recon)
if(TOMOPY_USE_MKL)
    add_subdirectory(${CMAKE_CURRENT_LIST_DIR}/gridrec)
endif()
if(TOMOPY_USE_OPENCV OR TOMOPY_USE_CUDA)
    add_subdirectory(${CMAKE_CURRENT_LIST_DIR}/accel)
endif()

=== examples/extended/rotation/CMakeLists.txt ===
#----------------------------------------------------------------------------
# Setup the project
#
cmake_minimum_required(VERSION 3.3 FATAL_ERROR)
project(PTL_Rotation_Examples LANGUAGES C CXX)


#----------------------------------------------------------------------------
# Find PTL project
#
find_package(PTL REQUIRED)
list(APPEND EXTERNAL_LIBRARIES ${PTL_LIBRARIES})
list(APPEND TARGET_INCLUDE_DIRECTORIES ${PROJECT_SOURCE_DIR}/source ${PTL_INCLUDE_DIRS})


#----------------------------------------------------------------------------
# OpenCV
#
set(OpenCV_COMPONENTS opencv_core opencv_imgproc opencv_highgui)
find_package(OpenCV QUIET COMPONENTS ${OpenCV_COMPONENTS})
if(NOT OpenCV_FOUND)
    message(STATUS "OpenCV not found! Skipping example '${PROJECT_NAME}'...")
    return()
endif()
list(APPEND EXTERNAL_LIBRARIES ${OpenCV_LIBRARIES})


#----------------------------------------------------------------------------
# Data files
#
configure_file(${PROJECT_SOURCE_DIR}/data/cameraman.tif
    ${CMAKE_BINARY_DIR}/data/cameraman.tif COPYONLY)


#----------------------------------------------------------------------------
# Source files
#
file(GLOB headers ${CMAKE_CURRENT_LIST_DIR}/source/*.hh)
file(GLOB sources ${CMAKE_CURRENT_LIST_DIR}/source/*.cc)

set(EXE_NAME rotation)

add_executable(${EXE_NAME} ${EXE_NAME}.cc
    ${sources} ${headers})

target_link_libraries(${EXE_NAME} PUBLIC
    ${EXTERNAL_LIBRARIES})

target_include_directories(${EXE_NAME} PRIVATE
    ${TARGET_INCLUDE_DIRECTORIES})

target_compile_options(${EXE_NAME} PUBLIC
    $<$<COMPILE_LANGUAGE:C>:${${PROJECT_NAME}_C_FLAGS}>
    $<$<COMPILE_LANGUAGE:CXX>:${${PROJECT_NAME}_CXX_FLAGS}>)


#----------------------------------------------------------------------------
# installation
if(NOT DEFINED PTL_DEVELOPER_INSTALL OR PTL_DEVELOPER_INSTALL)
    install(TARGETS ${EXE_NAME} DESTINATION bin)
endif()

=== source/libtomo/accel/CMakeLists.txt ===
# target properties based on build

file(GLOB accel_sources
    ${CMAKE_CURRENT_LIST_DIR}/cxx/*.cc)

set(ACCEL_LIBRARY_SOURCES ${accel_sources})

if(TOMOPY_USE_CUDA)

    file(GLOB CUDA_LIBRARY_SOURCES
        ${CMAKE_CURRENT_LIST_DIR}/gpu/*.cu)

    list(APPEND ACCEL_LIBRARY_SOURCES ${CUDA_LIBRARY_SOURCES})

    list(APPEND TARGET_INCLUDE_DIRECTORIES
        ${CMAKE_CUDA_TOOLKIT_INCLUDE_DIRECTORIES})

endif(TOMOPY_USE_CUDA)

add_library(libtomopy-accel SHARED ${ACCEL_LIBRARY_SOURCES})

target_link_libraries(libtomopy-accel
    PUBLIC tomopy::cuda-npp ${TOMOPY_EXTERNAL_LIBRARIES}
    PRIVATE ${TOMOPY_EXTERNAL_PRIVATE_LIBRARIES})

set(CUDA_PROPERTIES
    CUDA_STANDARD               ${CMAKE_CXX_STANDARD}
    CUDA_STANDARD_REQUIRED      ON
    CUDA_SEPARABLE_COMPILATION  ON
    CUDA_RESOLVE_DEVICE_SYMBOLS ON)

list(APPEND TARGET_INCLUDE_DIRECTORIES "${CMAKE_CURRENT_LIST_DIR}")
list(APPEND TARGET_INCLUDE_DIRECTORIES "${CMAKE_CURRENT_LIST_DIR}/../../include/accel")

# target properties
set_target_properties(libtomopy-accel
    PROPERTIES
    PREFIX ""
    RUNTIME_OUTPUT_DIRECTORY    ${OUTPUT_PATH}/tomopy/util/extern
    LIBRARY_OUTPUT_DIRECTORY    ${OUTPUT_PATH}/tomopy/util/extern
    ARCHIVE_OUTPUT_DIRECTORY    ${OUTPUT_PATH}/tomopy/util/extern
    INCLUDE_DIRECTORIES         "${TARGET_INCLUDE_DIRECTORIES}"
    C_STANDARD                  ${CMAKE_C_STANDARD}
    C_STANDARD_REQUIRED         ${CMAKE_C_STANDARD_REQUIRED}
    CXX_STANDARD                ${CMAKE_CXX_STANDARD}
    CXX_STANDARD_REQUIRED       ${CMAKE_CXX_STANDARD_REQUIRED}
    ${CUDA_PROPERTIES})

target_compile_definitions(libtomopy-accel PUBLIC
    ${${PROJECT_NAME}_DEFINITIONS})

target_compile_options(libtomopy-accel PUBLIC
    $<$<COMPILE_LANGUAGE:C>:${${PROJECT_NAME}_C_FLAGS}>
    $<$<COMPILE_LANGUAGE:CXX>:${${PROJECT_NAME}_CXX_FLAGS}>
    $<$<COMPILE_LANGUAGE:CUDA>:${${PROJECT_NAME}_CUDA_FLAGS}>)

install(TARGETS libtomopy-accel
    DESTINATION ${PYTHON_SITE_DIR}/tomopy/util/extern
    COMPONENT python)

=== source/libtomo/gridrec/CMakeLists.txt ===
if(TOMOPY_CXX_GRIDREC)
    SET_SOURCE_FILES_PROPERTIES("gridrec.c" PROPERTIES LANGUAGE CXX)
endif()

file(GLOB gridrec_tomo_sources
    ${CMAKE_CURRENT_LIST_DIR}/*.c)
file(GLOB gridrec_tomo_headers
    ${CMAKE_CURRENT_LIST_DIR}/../../include/gridrec/*.h
    ${CMAKE_CURRENT_LIST_DIR}/*.h)

# core sources
set(GRIDREC_SOURCES ${gridrec_tomo_headers} ${gridrec_tomo_sources})

# create library
add_library(libtomopy-gridrec SHARED ${GRIDREC_SOURCES})

# link library
target_link_libraries(libtomopy-gridrec PUBLIC ${TOMOPY_EXTERNAL_LIBRARIES}
    PRIVATE ${TOMOPY_EXTERNAL_PRIVATE_LIBRARIES})

# where to place the library
set(OUTPUT_PATH ${CMAKE_BINARY_DIR})

list(APPEND TARGET_INCLUDE_DIRECTORIES "${CMAKE_CURRENT_LIST_DIR}/../../include/gridrec")
list(APPEND TARGET_INCLUDE_DIRECTORIES "${CMAKE_CURRENT_LIST_DIR}")

# target properties
set_target_properties(libtomopy-gridrec
    PROPERTIES
    PREFIX ""
    RUNTIME_OUTPUT_DIRECTORY    ${OUTPUT_PATH}/tomopy/util/extern
    LIBRARY_OUTPUT_DIRECTORY    ${OUTPUT_PATH}/tomopy/util/extern
    ARCHIVE_OUTPUT_DIRECTORY    ${OUTPUT_PATH}/tomopy/util/extern
    INCLUDE_DIRECTORIES         "${TARGET_INCLUDE_DIRECTORIES}"
    C_STANDARD                  ${CMAKE_C_STANDARD}
    C_STANDARD_REQUIRED         ${CMAKE_C_STANDARD_REQUIRED}
    CXX_STANDARD                ${CMAKE_CXX_STANDARD}
    CXX_STANDARD_REQUIRED       ${CMAKE_CXX_STANDARD_REQUIRED})

target_compile_definitions(libtomopy-gridrec PUBLIC
    ${${PROJECT_NAME}_DEFINITIONS})

target_compile_options(libtomopy-gridrec PUBLIC
    $<$<COMPILE_LANGUAGE:C>:${${PROJECT_NAME}_C_FLAGS}>
    $<$<COMPILE_LANGUAGE:CXX>:${${PROJECT_NAME}_CXX_FLAGS}>)

install(TARGETS libtomopy-gridrec
    DESTINATION ${PYTHON_SITE_DIR}/tomopy/util/extern
    COMPONENT python)

## tomopy 1.10.4%2Bds1

=== debian/control ===
Source: tomopy
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian PaN Maintainers <debian-pan-maintainers@alioth-lists.debian.net>
Uploaders:
 Debian Python Team <team+python@tracker.debian.org>,
 Roland Mas <lolando@debian.org>
Section: contrib/python
Priority: optional
Build-Depends: dh-python, python3-setuptools, python3-all,
 python3-skbuild, python3-numpy, python3-scipy, python3-numexpr, python3-skimage,
 libopencv-dev, ninja-build, nvidia-cuda-toolkit, intel-mkl [amd64 i386],
 debhelper (>= 13)
Standards-Version: 4.5.1
Homepage: https://github.com/tomopy/tomopy
Vcs-Git: https://salsa.debian.org/python-team/packages/tomopy.git
Vcs-Browser: https://salsa.debian.org/python-team/packages/tomopy

Package: python3-tomopy
Architecture: any
Depends: ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends}, python3-numpy,
 python3-scipy, python3-numexpr, python3-skimage
Description: Python package for tomographic data processing and image reconstruction
 Features:
  * Image reconstruction algorithms for tomography.
  * Various filters, ring removal algorithms, phase retrieval algorithms.
  * Forward projection operator for absorption and wave propagation.

## tomopy 1.10.4+ds1

=== debian/changelog ===
tomopy (1.10.4+ds1-7) unstable; urgency=medium

  * Recommend python3-dxchange.

 -- Roland Mas <lolando@debian.org>  Tue, 31 Jan 2023 11:21:47 +0100

tomopy (1.10.4+ds1-6) unstable; urgency=medium

  * Depend on the actual version of libufo.

 -- Roland Mas <lolando@debian.org>  Wed, 11 Jan 2023 17:16:47 +0100

tomopy (1.10.4+ds1-5) unstable; urgency=medium

  * Team upload.
  * Do not hardcode compiler versions.
  * Add cmake flag -DCMAKE_CUDA_HOST_COMPILER=cuda-g++ to fix CUDA detection.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 16 Nov 2022 14:25:42 +0100

tomopy (1.10.4+ds1-4) unstable; urgency=medium

  [ Andreas Beckmann ]
  * rules: Ensure source/PTL exists.
  * Switch to B-D: nvidia-cuda-tookit-gcc.

  [ Roland Mas ]
  * Bug fix: "needs manual rebuild for opencv transition", thanks to
    Sebastian Ramacher (Closes: #1014248).
  * Also, force building with gcc-10 and g++-10.

 -- Roland Mas <lolando@debian.org>  Sat, 15 Oct 2022 12:20:44 +0200

tomopy (1.10.4+ds1-3) unstable; urgency=medium

  * Bug fix: "please restrict the B-D: intel-mkl to [amd64 i386]", thanks
    to Andreas Beckmann (Closes: #1006995).

 -- Roland Mas <lolando@debian.org>  Thu, 10 Mar 2022 13:56:32 +0100

tomopy (1.10.4+ds1-2) unstable; urgency=medium

  * Source-only upload for migration to testing.

 -- Roland Mas <lolando@debian.org>  Tue, 01 Feb 2022 20:09:10 +0100

tomopy (1.10.4+ds1-1) unstable; urgency=low

  * Initial upload (closes: #996481).

 -- Roland Mas <lolando@debian.org>  Thu, 21 Oct 2021 18:00:39 +0200

=== debian/control ===
Source: tomopy
Maintainer: Debian PaN Maintainers <debian-pan-maintainers@alioth-lists.debian.net>
Uploaders:
 Debian Python Team <team+python@tracker.debian.org>,
 Roland Mas <lolando@debian.org>
Section: contrib/python
Priority: optional
Build-Depends: dh-python, python3-setuptools, python3-all,
 python3-skbuild, python3-numpy, python3-scipy, python3-numexpr, python3-skimage,
 libopencv-dev,
 ninja-build,
 nvidia-cuda-toolkit-gcc [amd64 arm64 ppc64el],
 intel-mkl [amd64 i386],
 debhelper (>= 13)
Standards-Version: 4.5.1
Homepage: https://github.com/tomopy/tomopy
Vcs-Git: https://salsa.debian.org/python-team/packages/tomopy.git
Vcs-Browser: https://salsa.debian.org/python-team/packages/tomopy

Package: python3-tomopy
Architecture: any
Depends: ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends}, python3-numpy,
 python3-scipy, python3-numexpr, python3-skimage
Recommends: python3-dxchange
Description: Python package for tomographic data processing and image reconstruction
 Features:
  * Image reconstruction algorithms for tomography.
  * Various filters, ring removal algorithms, phase retrieval algorithms.
  * Forward projection operator for absorption and wave propagation.

=== debian/rules ===
#!/usr/bin/make -f

export PYBUILD_NAME=tomopy

%:
	dh $@ --with python3 --buildsystem=pybuild

PTLLINKS=VERSION CMakeLists.txt cmake source
execute_before_dh_auto_configure:
	mkdir -p source/PTL
	for i in $(PTLLINKS) ; do ln -s ../../PTL/$$i source/PTL/ ; done

execute_after_dh_auto_clean:
	for i in $(PTLLINKS) ; do rm -f source/PTL/$$i ; done

## tomopy 1.14.1+ds1

=== source/CMakeLists.txt ===
# ##############################################################################
# # General                                        # #
# ##############################################################################
# ensure PIC flag is set
set(PYTHON_SITE_DIR ${CMAKE_INSTALL_PREFIX}/source)
set(BUILD_STATIC_LIBS
    ON
    CACHE BOOL "Build static libraries")
set(BUILD_SHARED_LIBS
    OFF
    CACHE BOOL "Build shared libraries")
set(PTL_DEVELOPER_INSTALL
    OFF
    CACHE BOOL "Install headers, cmake export, and shared libs" FORCE)
set(CMAKE_POSITION_INDEPENDENT_CODE
    ON
    CACHE BOOL "Position independent code" FORCE)
# ------------------------------------------------------------------------------#
#
# PTL submodule
#
# ------------------------------------------------------------------------------#
checkout_git_submodule(
  RECURSIVE
  TEST_FILE
  CMakeLists.txt
  RELATIVE_PATH
  source/PTL
  WORKING_DIRECTORY
  ${PROJECT_SOURCE_DIR})

if(TOMOPY_USE_PTL)
  add_subdirectory(PTL)
  if(BUILD_STATIC_LIBS)
    list(APPEND TOMOPY_EXTERNAL_LIBRARIES ptl-static)
  else()
    list(APPEND TOMOPY_EXTERNAL_LIBRARIES ptl-shared)
  endif()
  list(APPEND ${PROJECT_NAME}_DEFINITIONS TOMOPY_USE_PTL)
endif()

# ------------------------------------------------------------------------------#
#
# TomoPy Python module
#
# ------------------------------------------------------------------------------#

# where to place the library
set(OUTPUT_PATH ${CMAKE_BINARY_DIR})

add_subdirectory(${CMAKE_CURRENT_LIST_DIR}/libtomo)

# ------------------------------------------------------------------------------#
#
# Code coverage
#
# ------------------------------------------------------------------------------#
if(TOMOPY_USE_COVERAGE)
  foreach(_SRC_FILE ${LIBRARY_SOURCES})
    string(REPLACE "${CMAKE_CURRENT_SOURCE_DIR}" "${CMAKE_CURRENT_BINARY_DIR}"
                   _BIN_FILE "${_SRC_FILE}")
    configure_file(${_SRC_FILE} ${_BIN_FILE} COPYONLY)
  endforeach()
endif()

=== source/libtomo/accel/CMakeLists.txt ===
set(HEADERS "${tomopy_SOURCE_DIR}/include/libtomo/accel.h"
            "${tomopy_SOURCE_DIR}/include/libtomo/macros.h")

tomopy_add_library(
  tomo-accel
  SHARED
  cxx/common.cc
  cxx/mlem.cc
  cxx/sirt.cc
  common.hh
  constants.hh
  cuda.h
  data.hh
  macros.hh
  profiler.hh
  typedefs.hh
  utils.hh
  ${HEADERS})

target_include_directories(
  tomo-accel
  PUBLIC $<BUILD_INTERFACE:${tomopy_SOURCE_DIR}/include>
         $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
  PRIVATE ${CMAKE_CURRENT_LIST_DIR})

if(TRUE)
  # FIXME: Need PTL headers regardless of whether we use PTL
  target_include_directories(tomo-accel
                             PRIVATE ${tomopy_SOURCE_DIR}/source/PTL/source)
endif()

if(TOMOPY_USE_CUDA)

  target_sources(tomo-accel PRIVATE gpu/common.cu gpu/mlem.cu gpu/sirt.cu
                                    gpu/utils.cu)

  target_include_directories(tomo-accel
                             PRIVATE ${CMAKE_CUDA_TOOLKIT_INCLUDE_DIRECTORIES})

  target_link_libraries(tomo-accel PRIVATE tomopy::cuda-npp)

  set(CUDA_PROPERTIES
      CUDA_STANDARD
      ${CMAKE_CXX_STANDARD}
      CUDA_STANDARD_REQUIRED
      ON
      CUDA_SEPARABLE_COMPILATION
      ON
      CUDA_RESOLVE_DEVICE_SYMBOLS
      ON)

  set_target_properties(tomo-accel PROPERTIES ${CUDA_PROPERTIES})

endif(TOMOPY_USE_CUDA)

target_link_libraries(tomo-accel PRIVATE ${TOMOPY_EXTERNAL_LIBRARIES}
                                         ${TOMOPY_EXTERNAL_PRIVATE_LIBRARIES})

target_compile_definitions(tomo-accel PRIVATE ${${PROJECT_NAME}_DEFINITIONS})

target_compile_options(
  tomo-accel
  PRIVATE $<$<COMPILE_LANGUAGE:C>:${${PROJECT_NAME}_C_FLAGS}>
          $<$<COMPILE_LANGUAGE:CXX>:${${PROJECT_NAME}_CXX_FLAGS}>
          $<$<COMPILE_LANGUAGE:CUDA>:${${PROJECT_NAME}_CUDA_FLAGS}>)

install(TARGETS tomo-accel EXPORT libtomoTargets)

install(
  FILES ${HEADERS}
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/libtomo
  COMPONENT Headers)

=== source/libtomo/gridrec/CMakeLists.txt ===
set(HEADERS "${tomopy_SOURCE_DIR}/include/libtomo/filters.h"
            "${tomopy_SOURCE_DIR}/include/libtomo/gridrec.h")

if(TOMOPY_CXX_GRIDREC)
  set_source_files_properties("gridrec.c" PROPERTIES LANGUAGE CXX)
endif()

tomopy_add_library(tomo-gridrec SHARED gridrec.c pal.h ${HEADERS})

if(TOMOPY_USE_MKL)
  find_package(MKL REQUIRED)
  target_include_directories(tomo-gridrec PRIVATE ${MKL_INCLUDE_DIRS})
  target_link_options(tomo-gridrec PRIVATE
                      $<$<COMPILE_LANGUAGE:CXX>:${MKL_CXX_LINK_FLAGS}>)
  target_link_libraries(tomo-gridrec PRIVATE ${MKL_LIBRARIES})
  target_compile_definitions(tomo-gridrec PRIVATE TOMOPY_USE_MKL)
else()
  if(TOMOPY_CXX_GRIDREC)
    message(
      WARNING "TOMOPY_CXX_GRIDREC with FFTW3 is not officially supported.")
  endif()
  # FFTW doesn't officially support CMAKE, they prefer PkgConfig.
  find_package(PkgConfig REQUIRED)
  pkg_search_module(FFTW REQUIRED fftw3f IMPORTED_TARGET)
  # Must link with thread aware fftw3f in order to make planner thread safe
  target_link_libraries(tomo-gridrec PRIVATE fftw3f_threads fftw3f)
  target_compile_definitions(tomo-gridrec PRIVATE TOMOPY_USE_FFTW)
endif()

# link library to math.h
if(NOT WIN32)
  target_link_libraries(tomo-gridrec PUBLIC m)
endif()

target_include_directories(
  tomo-gridrec
  PUBLIC $<BUILD_INTERFACE:${tomopy_SOURCE_DIR}/include>
         $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
  PRIVATE ${CMAKE_CURRENT_LIST_DIR})

target_compile_definitions(tomo-gridrec PRIVATE ${${PROJECT_NAME}_DEFINITIONS})

target_compile_options(
  tomo-gridrec PRIVATE $<$<COMPILE_LANGUAGE:C>:${${PROJECT_NAME}_C_FLAGS}>
                       $<$<COMPILE_LANGUAGE:CXX>:${${PROJECT_NAME}_CXX_FLAGS}>)

install(TARGETS tomo-gridrec EXPORT libtomoTargets)

install(
  FILES ${HEADERS}
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/libtomo
  COMPONENT Headers)

=== source/libtomo/misc/CMakeLists.txt ===
set(HEADERS
    "${tomopy_SOURCE_DIR}/include/libtomo/morph.h"
    "${tomopy_SOURCE_DIR}/include/libtomo/remove_ring.h"
    "${tomopy_SOURCE_DIR}/include/libtomo/median_filt3d.h")

tomopy_add_library(
  tomo-misc
  SHARED
  morph.c
  remove_ring.c
  median_filt3d.c
  ${HEADERS})

find_package(OpenMP REQUIRED COMPONENTS C)
target_link_libraries(tomo-misc PRIVATE OpenMP::OpenMP_C)
if (WIN32)
target_compile_options(
  tomo-misc PRIVATE $<$<COMPILE_LANGUAGE:C>:/openmp:experimental>)
endif()

target_include_directories(
  tomo-misc
  PUBLIC $<BUILD_INTERFACE:${tomopy_SOURCE_DIR}/include>
         $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
  PRIVATE ${CMAKE_CURRENT_LIST_DIR})

# link library to math.h
if(NOT WIN32)
  target_link_libraries(tomo-misc PRIVATE m)
endif()

install(TARGETS tomo-misc EXPORT libtomoTargets)

install(
  FILES ${HEADERS}
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/libtomo
  COMPONENT Headers)

=== debian/changelog ===
tomopy (1.14.1+ds1-1) unstable; urgency=medium

  * New upstream release.
  * Disable Intel MKL (FTBFS).
  * Tweak search path for private libtomo-* libraries (this fixes autopkgtest).

 -- Roland Mas <lolando@debian.org>  Wed, 16 Aug 2023 18:55:05 +0200

tomopy (1.10.4+ds1-9) unstable; urgency=medium

  * Add autopkgtest.
  * Load architecture-specific shared object when relevant.

 -- Roland Mas <lolando@debian.org>  Tue, 21 Feb 2023 17:58:40 +0100

tomopy (1.10.4+ds1-8) unstable; urgency=medium

  * Bug fix: "please fix build on atomic architectures", thanks to
    Gianfranco Costamagna (Closes: #1030295).

 -- Roland Mas <lolando@debian.org>  Tue, 21 Feb 2023 15:40:46 +0100

=== debian/control ===
--- 
+++ 
@@ -8,9 +8,12 @@
 Build-Depends: dh-python, python3-setuptools, python3-all,
  python3-skbuild, python3-numpy, python3-scipy, python3-numexpr, python3-skimage,
  libopencv-dev,
- ninja-build,
  nvidia-cuda-toolkit-gcc [amd64 arm64 ppc64el],
- intel-mkl [amd64 i386],
+# intel-mkl [amd64 i386],
+ libfftw3-dev,
+ pybuild-plugin-pyproject,
+ python3-nose,
+ rename,
  debhelper (>= 13)
 Standards-Version: 4.5.1
 Homepage: https://github.com/tomopy/tomopy

=== debian/rules ===
#!/usr/bin/make -f

export PYBUILD_NAME=tomopy
include /usr/share/dpkg/architecture.mk
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
CFLAGS+=$(CPPFLAGS)
CXXFLAGS+=$(CPPFLAGS)

LIBTOMOPATH=/usr/lib/python3/dist-packages/tomopy/util/extern

export CMAKE_OPTIONS := \
  -DCMAKE_CXX_FLAGS="$(CXXFLAGS)" \
  -DCMAKE_SHARED_LINKER_FLAGS_RELEASE="$(LDFLAGS)" \
  -DWITH_SHARED_LIB=1 \
  -DWITH_STATIC_LIB=0 \
  -DCMAKE_INSTALL_LIBDIR=$(LIBTOMOPATH) \
  -DCMAKE_BUILD_TYPE=Release

%:
	dh $@ --with python3 --buildsystem=pybuild --test-nose

PTLLINKS=VERSION CMakeLists.txt cmake source
override_dh_auto_configure:
	mkdir -p source/PTL
	for i in $(PTLLINKS) ; do ln -s ../../PTL/$$i source/PTL/ ; done
	dh_auto_configure -Spython3 --buildsystem=pybuild -O--test-nose
	dh_auto_configure -Scmake -- $(CMAKE_OPTIONS)

override_dh_auto_build:
	dh_auto_build -Spython3 --buildsystem=pybuild -O--test-nose
	dh_auto_build -Scmake
	dh_auto_install -Scmake

override_dh_auto_install:
	dh_auto_install -Spython3 --buildsystem=pybuild -O--test-nose
	dh_auto_install -Scmake

execute_after_dh_auto_clean:
	for i in $(PTLLINKS) ; do rm -f source/PTL/$$i ; done

execute_before_dh_auto_test:
	cp debian/python3-tomopy/$(LIBTOMOPATH)/*.so $(CURDIR)/.pybuild/cpython*/build/tomopy/util/extern

execute_after_dh_auto_test:
	rm -f $(CURDIR)/.pybuild/cpython*/build/tomopy/util/extern/*.so

## tomopy 1.15.0+ds1

=== debian/changelog ===
tomopy (1.15.0+ds1-8) unstable; urgency=medium

  * Bug fix: "FTBFS: test_shape fails on single-CPU systems", thanks to
    Santiago Vila (Closes: #1083180).

 -- Roland Mas <lolando@debian.org>  Sat, 05 Oct 2024 10:13:17 +0200

tomopy (1.15.0+ds1-7) unstable; urgency=medium

  * Only try to use OpenMP if present.

 -- Roland Mas <lolando@debian.org>  Tue, 01 Oct 2024 22:44:35 +0200

tomopy (1.15.0+ds1-6) unstable; urgency=medium

  * Only try to use MKL if present.

 -- Roland Mas <lolando@debian.org>  Tue, 01 Oct 2024 22:05:44 +0200

tomopy (1.15.0+ds1-5) unstable; urgency=medium

  * Include upstream patch to port to Scipy 1.14, this fixes: "tests fail
    with scipy 1.14", thanks to Drew Parsons (Closes: #1082288).

 -- Roland Mas <lolando@debian.org>  Fri, 27 Sep 2024 20:24:11 +0200

tomopy (1.15.0+ds1-4) unstable; urgency=medium

  * Re-enable Intel MKL; this now works with only an extra build-depends,
    and fixes: "CUDA + MKL =&gt; FTBFS", thanks to Andreas Beckmann (Closes: #1023347).

 -- Roland Mas <lolando@debian.org>  Wed, 18 Sep 2024 15:20:36 +0200

tomopy (1.15.0+ds1-3) unstable; urgency=medium

  * Switch to pytest, to fix "build-depends on python3-nose or uses it for
    autopkgtest", thanks to Alexandre Detiste (Closes: #1081427).

 -- Roland Mas <lolando@debian.org>  Wed, 11 Sep 2024 17:54:36 +0200

tomopy (1.15.0+ds1-2) unstable; urgency=medium

  * Increase testsuite tolerance a bit to cope with i386.

 -- Roland Mas <lolando@debian.org>  Wed, 11 Sep 2024 16:31:15 +0200

tomopy (1.15.0+ds1-1) unstable; urgency=medium

  * New upstream release.
  * Update Build-Depends.
  * Backport patch from upstream to fix "tests fail with scipy 1.13",
    thanks to Drew Parsons (Closes: #1073546).
  * This also seems to fix: "FTBFS with CUDA 12: nvcc fatal :
    Unsupported gpu architecture &#39;compute_35&#39;", thanks to Andreas
    Beckmann (Closes: #1036684). 
  * Bug fix: "FTBFS with two supported python versions", thanks to Andreas
    Beckmann (Closes: #1061064).
  * Bug fix: "please add autopkgtests (to add coverage for
    python3-numpy)", thanks to Sandro Tosi (Closes: #1035242). 

 -- Roland Mas <lolando@debian.org>  Wed, 11 Sep 2024 15:23:43 +0200

=== debian/rules ===
#!/usr/bin/make -f

export PYBUILD_NAME=tomopy
include /usr/share/dpkg/architecture.mk
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
CFLAGS+=$(CPPFLAGS)
CXXFLAGS+=$(CPPFLAGS)

LIBTOMOPATH=/usr/lib/python3/dist-packages/tomopy/util/extern

ifneq (,$(wildcard /usr/include/mkl/mkl.h))
  USE_MKL:=ON
else
  USE_MKL:=OFF
endif

ifneq (,$(wildcard /usr/lib/llvm-*/lib/clang/*/include/omp.h))
  USE_OPENMP:=ON
else
  USE_OPENMP:=OFF
endif

export CMAKE_OPTIONS := \
  -DCMAKE_CXX_FLAGS="$(CXXFLAGS)" \
  -DCMAKE_SHARED_LINKER_FLAGS_RELEASE="$(LDFLAGS)" \
  -DWITH_SHARED_LIB=1 \
  -DWITH_STATIC_LIB=0 \
  -DCMAKE_INSTALL_LIBDIR=$(LIBTOMOPATH) \
  -DCMAKE_CUDA_HOST_COMPILER=cuda-g++ \
  -DMKL_ROOT_DIR=/usr \
  -DMKL_INCLUDE_DIR=/usr/include/mkl \
  -DCMAKE_BUILD_TYPE=Release \
  -DTOMOPY_USE_MKL=$(USE_MKL) \
  -DTOMOPY_USE_OPENMP=$(USE_OPENMP)

%:
	dh $@ --with python3 --buildsystem=pybuild --test-pytest

PTLLINKS=VERSION CMakeLists.txt cmake source
override_dh_auto_configure:
	mkdir -p source/PTL
	for i in $(PTLLINKS) ; do ln -s ../../PTL/$$i source/PTL/ ; done
	dh_auto_configure -Spython3 --buildsystem=pybuild -O--test-pytest
	dh_auto_configure -Scmake -- $(CMAKE_OPTIONS)

override_dh_auto_build:
	dh_auto_build -Spython3 --buildsystem=pybuild -O--test-pytest
	dh_auto_build -Scmake
	dh_auto_install -Scmake

override_dh_auto_install:
	dh_auto_install -Spython3 --buildsystem=pybuild -O--test-pytest
	dh_auto_install -Scmake

execute_after_dh_auto_clean:
	for i in $(PTLLINKS) ; do rm -f source/PTL/$$i ; done

execute_before_dh_auto_test:
	for v in $$(py3versions -sv) ; do cp -v debian/python3-tomopy/$(LIBTOMOPATH)/*.so $(CURDIR)/.pybuild/cpython3_$${v}_tomopy/build/tomopy/util/extern ; done

execute_after_dh_auto_test:
	rm -f $(CURDIR)/.pybuild/cpython*/build/tomopy/util/extern/*.so

## tomopy 1.15.2%2Bds1

=== source/CMakeLists.txt ===
--- 
+++ 
@@ -20,25 +20,17 @@
 # PTL submodule
 #
 # ------------------------------------------------------------------------------#
-checkout_git_submodule(
-  RECURSIVE
-  TEST_FILE
-  CMakeLists.txt
-  RELATIVE_PATH
-  source/PTL
-  WORKING_DIRECTORY
-  ${PROJECT_SOURCE_DIR})
-
-if(TOMOPY_USE_PTL)
-  add_subdirectory(PTL)
-  if(BUILD_STATIC_LIBS)
-    list(APPEND TOMOPY_EXTERNAL_LIBRARIES ptl-static)
-  else()
-    list(APPEND TOMOPY_EXTERNAL_LIBRARIES ptl-shared)
-  endif()
-  list(APPEND ${PROJECT_NAME}_DEFINITIONS TOMOPY_USE_PTL)
+if(TOMOPY_USE_OPENCV OR TOMOPY_USE_CUDA)
+  checkout_git_submodule(
+    RECURSIVE
+    TEST_FILE
+    CMakeLists.txt
+    RELATIVE_PATH
+    source/PTL
+    WORKING_DIRECTORY
+    ${PROJECT_SOURCE_DIR})
+  add_subdirectory(PTL EXCLUDE_FROM_ALL)
 endif()
-
 # ------------------------------------------------------------------------------#
 #
 # TomoPy Python module
